#
# this spec-file requires rpm-3.0 or newer
#
%define momorel 27
%define with_gcc296 1
%define GCC_VERSION 2.95.3
%define target_alias %{_target_cpu}-%{_vendor}-linux

Summary: GNU Compiler Collection - Core package including C compiler
Name: gcc2.95.3
Version: %{GCC_VERSION}
Release: %{momorel}m
License: GPL
Group: Development/Languages
Source0: ftp://ftp.gnu.org/gnu/gcc/gcc-%version/gcc-core-%version.tar.gz
Source1: ftp://ftp.gnu.org/gnu/gcc/gcc-%version/gcc-g++-%version.tar.gz
%if !%{with_gcc296}
Source3: gcc-libstdc++-compat.tar.bz2
%endif
Patch: gcc-2.95.2-complex.dif
Patch3: gcc-include.diff
Patch4: ada.diff
Patch5: gpc.diff
Patch9: gcc-accept-doublecolon.diff
Patch10: gcc.disable-rerun.patch
Patch14: gcc-extension-warn.diff
Patch16: alpha-extra.diff
Patch18: gcc-2.95.2-rs6000.diff
Patch21: weak.diff
Patch22: crtstuff.diff
Patch23: gcc-2.95.4-1.patch
Patch24: ppc.diff
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Url: http://gcc.gnu.org/
%ifarch ppc
BuildRequires: binutils >= 2.9.5.0.14
Requires: binutils >= 2.9.5.0.14
%else
Requires: binutils >= 2.9.1.0.23
%endif
Prereq: info
%if %{with_gcc296}
Requires: libstdc++2.96 = 2.96
Requires: libstdc++2.96-devel = 2.96
%else
Requires: libstdc++%{GCC_VERSION} = %{GCC_VERSION}
%endif
NoSource: 0
NoSource: 1

%description
GCC, the GNU Compiler Collection, is a free software project that intends to
further the development of GNU compilers using an open development
environment. The gcc package contains the GCC C compiler, a compiler aimed
at integrating all the optimizations and features necessary for a
high-performance and stable development environment.

Install gcc if you'd like to use the GNU Compiler Collection C compiler, you
will also need to install the cpp package.

%if !%{with_gcc296}
%package -n libstdc++2.95.3
Summary: GNU c++ library
Group: System Environment/Libraries
Obsoletes: gcc-libstdc++
Obsoletes: compat-libstdc++
Obsoletes: libstdc++compat
Provides: libstdc++-compat
Provides: libstdc++-libc6.1-1.so.2

%description -n libstdc++2.95.3
The libstdc++ package contains a snapshot of the GCC Standard C++
Library v3, an ongoing project to implement the ISO 14882 Standard C++
library.
%endif

%prep
%setup -q -n gcc-2.95.3 -b 1
%patch -p0
%patch18 -p0
%patch3 -p0
%patch4 -p0
%patch9 -p0
%patch10 -p0
%patch5 -p0
%patch16 -p0
%patch21 -p0
%patch22 -p0
%ifarch ppc
%patch23 -p0
%patch24 -p0
%endif

# we don't need to build texinfo on a current Linux installation
rm -rf texinfo

%if !%{with_gcc296}
mkdir compat
tar xzf %{SOURCE3} -C compat
%endif

%build
rm -rf obj-gcc-$RPM_ARCH
mkdir obj-gcc-$RPM_ARCH
cd obj-gcc-$RPM_ARCH

../configure \
	--prefix=/usr \
	--enable-shared \
	--enable-threads \
	--with-cpp-install-dir=../lib \
	%{target_alias} 2>&1 | tee ../build.log

export PATH=$PATH:/sbin:/usr/sbin

make bootstrap-lean 2>&1 | tee -a ../build.log

# workaround a bug in the handling of MAKEINFO in gcc-2.95
find -name "*.info"|xargs rm -f
find -name "*.info-[1-9]*"|xargs rm -f
make info MAKEINFO="makeinfo --no-split" | tee -a ../build.log

if [ -x /usr/bin/runtest ]; then
	make -k check 2>&1 | tee -a ../build.log
else
	echo "Dejagnu not installed, no selftests have been run." > ../build.log
fi
../contrib/warn_summary < ../build.log >../warn.summary
../contrib/test_summary -i ../warn.summary \
	> ../check.summary

%install
SRCDIR="$PWD"
rm -rf %{buildroot}
cd obj-gcc-$RPM_ARCH

export PATH=$PATH:/sbin:/usr/sbin

make install \
	prefix=%{buildroot}/usr \
	MAKEINFO="makeinfo --no-split"

mv %{buildroot}/usr/bin/gcc %{buildroot}/usr/bin/gcc_2_95_3
mv %{buildroot}/usr/bin/g++ %{buildroot}/usr/bin/g++_2_95_3

(cd %{buildroot}%{_bindir}; ln -sf gcc_2_95_3 kgcc)

ln -sf cpp0 %{buildroot}/usr/lib/gcc-lib/%{target_alias}/2.95.3/cpp
ln -sf cpp0 %{buildroot}/usr/lib/gcc-lib/%{target_alias}/2.95.3/tradcpp0

%if !%{with_gcc296}
#install the compatibility libstdc++ library
%ifarch i386 i586 i686
[ -d ../compat/i386 ] && install -m 755 ../compat/i386/* %{buildroot}/usr/lib/
%else
%ifarch alpha alphaev5
[ -d ../compat/alpha ] && install -m 755 ../compat/alpha/* %{buildroot}/usr/lib/
%else
[ -d ../compat/$RPM_ARCH ] && install -m 755 ../compat/$RPM_ARCH/* %{buildroot}/usr/lib/
%endif
%endif

# This is required for the old RedHat 6. based programs ...
( 
cd %{buildroot}/usr/lib 
%ifnarch ppc
ln -sf libstdc++-2-libc6.2-1-2.9.0.so libstdc++-libc6.1-1.so.2
%else
ln -sf libstdc++-2-libc6.1-1.1-2.9.0.so libstdc++-libc6.1-1.1.so.2 
%endif
)
%endif

# remove duplicate files
rm -f %{buildroot}/lib/cpp
rm -f %{buildroot}/usr/bin/c++
rm -f %{buildroot}/usr/bin/c++filt
rm -f %{buildroot}/usr/bin/cpp
rm -f %{buildroot}/usr/bin/gcov
rm -f %{buildroot}/usr/bin/protoize
rm -f %{buildroot}/usr/bin/unprotoize
rm -f %{buildroot}/usr/lib/libiberty.a
rm -f %{buildroot}/usr/lib/libstdc++-3-libc*2.10.0.*
rm -f %{buildroot}/usr/lib/libstdc++-libc*.so.3
rm -rf %{buildroot}/usr/include
rm -rf %{buildroot}/usr/man
rm -rf %{buildroot}/usr/info
%ifarch i386 i586 i686
rm -f %{buildroot}/usr/bin/i586-momonga-linux-gcc
%endif
%ifarch ppc
rm -f %{buildroot}/usr/bin/ppc-momonga-linux-gcc
rm -f %{buildroot}/usr/lib/nof/libiberty.a
rm -f %{buildroot}/usr/lib/nof/libstdc++-3-libc6.3-2-2.10.0.a
rm -f %{buildroot}/usr/lib/nof/libstdc++-3-libc6.3-2-2.10.0.so
%endif

%clean
rm -rf %{buildroot}

%if !%{with_gcc296}
%post -n libstdc++2.95.3
/sbin/ldconfig

%postun -n libstdc++2.95.3
/sbin/ldconfig
%endif

%files
%defattr(-,root,root)
%doc README* COPYING COPYING.LIB check.summary warn.summary build.log
/usr/bin/g++_2_95_3
/usr/bin/gcc_2_95_3
/usr/bin/kgcc
%dir /usr/lib/gcc-lib/%{target_alias}/2.95.3
/usr/lib/gcc-lib/%{target_alias}/2.95.3/*

%if !%{with_gcc296}
%files -n libstdc++2.95.3
%defattr(-,root,root)
%{_prefix}/%{_lib}/libstdc++-3-libc*2.10.0.*
%{_prefix}/%{_lib}/libstdc++-libc*.so.3
%ifarch i386 i486 i586 i686 alpha alphaev5
%{_prefix}/lib/libg++.so.2.7.2.8
%{_prefix}/lib/libstdc++.so.2.7.2.8
%{_prefix}/lib/libstdc++.so.2.8.0
%{_prefix}/lib/libstdc++-2-libc6*-1*-2.9.0.so
%{_prefix}/lib/libstdc++.so.2.9.dummy
%{_prefix}/lib/libstdc++-libc6.1-1*.so.2
%endif
%ifarch sparc
%{_prefix}/lib/libstdc++.so.2.8.0
# %{_prefix}/lib/libstdc++-2-libc6*-1-2.9.0.so
# %{_prefix}/lib/libstdc++-libc6.1-1.so.2
%{_prefix}/lib/libstdc++.so.2.9.dummy
%endif
%{_prefix}/lib/libstdc++-3-libc6.2-2-2.10.0.a
%{_prefix}/lib/libstdc++-libc6.2-2.a.3
%dir %{_prefix}/include/g++-3
%{_prefix}/include/g++-3/*
%endif

%changelog
* Tue Jun 22 2004 mutecat <mutecat@momonga-linux.org>
- (2.95.3-27m)
- ppc youni shuusei

* Fri Mar 19 2004 Toru Hoshina <t@momonga-linux.org>
- (2.95.3-26m)
- revised spec for enabling rpm 4.2.

* Sat Jul 19 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (2.95.3-25m)
- rebuild against glibc-2.3.2

* Mon Jul  7 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.95.3-24m)
- 'redhat' -> '%{_vendor}'

* Sun Jul  6 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.95.3-23m)
- rebuild against rpm-4.0.4-52m

* Thu Mar 20 2003 KOMATSU Shinichiro <koma2@momonga-linux.org>
- (2.95.3-22m)
- add Requires: libstdc++2.96-devel

* Mon Nov  4 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (2.95.3-21m)
- resolve conflicts against gcc2.96

* Sat May 25 2002 Toru Hoshina <t@kondara.org>
- (2.95.3-20k)
- cancel gcc 3.1 at this time.

* Sat May 25 2002 Toru Hoshina <t@kondara.org>
- (2.95.3-18k)
- g++_2_95_3 added.

* Tue Apr 30 2002 Kenta MURATA <muraken@kondara.org>
- (2.95.3-16k)
- /sbin/install-info -> info in PreReq.

* Sun Jan 27 2002 MATSUDA, Daiki <dyky@df-usa.com>
- (2.95.3-14k)
- link kgcc to gcc_2_95_3 for VMware

* Mon Nov 12 2001 Shingo Akagaki <dora@kondara.org>
- (2.95.3-12k)
- nigirisugi /usr/lib/gcc-lib

* Fri Oct 19 2001 Toru Hoshina <t@kondara.org>
- (2.95.3-10k)
- applied some patches from SuSE.

* Tue Aug 21 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (2.95.3-8k)
- add g++ source, because some kernel modules requires g++ cpp

* Wed Apr 18 2001 Toru Hoshina <toru@df-usa.com>
- (2.95.3-6k)
- remove link to egcs.

* Mon Apr 16 2001 Toru Hoshina <toru@df-usa.com>
- (2.95.3-4k)
- suma----so!

* Sat Apr  7 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (2.95.3-2k)
- Initiation
